//////////////////////////////////////////////////////////////////////////////////////
//
// pixel.h
//
// (C) Copyright 2000 Michael Landers (mykel@earthling.net)
//
// Header file for pixel manipulation speed ups
//
// This is a cut down version for smear
//
// pxlSetupYCoordinates(int height, int pitch)
// 	Setup Y table mapping
//
// pxlXYPixelPointer(unsigned long *Video, int X, int Y)
// 	Return a pointer to the pixel in position (X, Y) of the graphic Video
//
// pxlXYPixel(unsigned long *Video, int X, int Y)
// 	The pixel value of above rather than pointer
//
//////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////
//
// Pixel definition
//
//////////////////////////////////////////////////////////////////////////////////////
typedef	union
{
	unsigned long	ul;
	struct
	{
		unsigned char	r;
		unsigned char	g;
		unsigned char	b;
		unsigned char	a;
	}		uc;
}	PixelType;

//////////////////////////////////////////////////////////////////////////////////////
//
// Coordinate speed ups
//
//////////////////////////////////////////////////////////////////////////////////////

extern	int	*yCoordinates;
extern	int	yCoordinatesAllocated;
extern	int	yCoordinatesHeight;
extern	int	yCoordinatesPitch;

#define	pxlSetupYCoordinates(height, pitch)				    \
if (yCoordinatesPitch != pitch || yCoordinatesHeight != height)		    \
{									    \
	int	pxlSetupYCoordinates_i;					    \
	int	pxlSetupYCoordinates_v;					    \
	int	*pxlSetupYCoordinates_yp;				    \
									    \
	yCoordinatesPitch = pitch;					    \
	yCoordinatesHeight = height;					    \
									    \
	if (yCoordinatesAllocated < height)				    \
	{								    \
		if (yCoordinatesAllocated > 0)				    \
			free(yCoordinates);				    \
									    \
		yCoordinatesAllocated = height;				    \
		yCoordinates =						    \
			(int *)malloc(sizeof(int) * yCoordinatesAllocated); \
	}								    \
									    \
	for (pxlSetupYCoordinates_i = 0,				    \
	     pxlSetupYCoordinates_v = 0,				    \
	     pxlSetupYCoordinates_yp = yCoordinates;			    \
	     								    \
	     pxlSetupYCoordinates_i < height;				    \
	     								    \
	     pxlSetupYCoordinates_i++,					    \
	     pxlSetupYCoordinates_v += pitch,				    \
	     pxlSetupYCoordinates_yp++)					    \
		*pxlSetupYCoordinates_yp = pxlSetupYCoordinates_v;	    \
}

#define	pxlXYPixelPointer(Video, X, Y)					      \
	(Video + *(yCoordinates + Y) + X)

#define	pxlXYPixel(Video, X, Y)						      \
	*pxlXYPixelPointer(Video, X, Y)
