//////////////////////////////////////////////////////////////////////
//
// Just a generic include file for smear.  Includes all the others
// that are required.  Also a bit of config here, a bit of debug
// there.
// 
//////////////////////////////////////////////////////////////////////

#ifndef	__SMEAR_H__
#define	__SMEAR_H__

//////////////////////////////////////////////////////////////////////////////////////
// Currently the thread system is unstable, I strongly recommend not
// defining this
#undef	USE_MAP_THREADS

//////////////////////////////////////////////////////////////////////////////////////
// Currently the thread system is unstable, I strongly recommend not
// defining this
#undef	USE_OLD_LINE_BASED_MAPS

//////////////////////////////////////////////////////////////////////////////////////
// This determines how long (in ms) the system tries to build a map per frame
// The higher this is the slow things run, but the quicker you can change
// maps.
#define	MAP_FASTBUILD	25
#define	MAP_SLOWBUILD	5

//////////////////////////////////////////////////////////////////////////////////////
// These defines determine how often the particle system sees if it needs to
// add more particles and how many is the maximum number of particles to run
#define	MAX_PARTICLES_RUNNING	3
#define	PARTICLE_TRY_TIMEOUT	1000		// Once per second

//////////////////////////////////////////////////////////////////////////////////////
// These determine the song fade and total display time (in frames).  The
// fade time is currently unused.
#define	SONG_FADE_TIME	25
#define	SONG_TOTAL_TIME	150

//////////////////////////////////////////////////////////////////////////////////////
// What is the maximum number of each script type
#define	MAX_ENVIRONMENTS	1024

//////////////////////////////////////////////////////////////////////////////////////
// How many render cycles info shall be displayed after a click
#define CLICKED_LIFETIME	150

//////////////////////////////////////////////////////////////////////////////////////
// Vis Definitions
#define	VIS_LONG_NAME	"smear :: mykel : xplo"
#define	VIS_SHORT_NAME	"smear"
#define	VIS_VERSION	"1.60"
#define	VIS_AUTHOR	"mykel@earthling.net / xplo@xplo.org"

//////////////////////////////////////////////////////////////////////////////////////
// How much wave data is supplied by sonique?
#define WAVE_DATA_SIZE	512

//////////////////////////////////////////////////////////////////////////////////////
// A stupid debug function
#define	STUPID(s) { FILE *fp = fopen("c:\\stupid", "a"); fprintf(fp, "%s\n", s); fclose(fp); }

//////////////////////////////////////////////////////////////////////////////////////
// System include files
#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <malloc.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <setjmp.h>
#include <io.h>
#include <process.h>
#include <direct.h>
#include <memory.h>

//////////////////////////////////////////////////////////////////////////////////////
// And my include files
#include "vis.h"

#include "parser.h"
#include "fnlist.h"
#include "pixel.h"
#include "wfstuff.h"
#include "ssm.h"
#include "smearapi.h"

#ifdef	USE_MAP_THREADS
#include "thread.h"
#endif

#endif
