#include "smear.h"

/*
 * This is an exported function that can be used to control smear
 */

DLLEXPORT int
SmearAPI(int cmd, char *infile, char *errorSpace)
{
	extern	int	isCheck;
	extern	char	*ic2string;
	Environment 	*ep;

	if (errorSpace)
		errorSpace[0] = '\0';

	switch (cmd)
	{
	case SMAPI_CHECKFILE:
		isCheck = 2;
		ic2string = errorSpace;

		ep = ParseFile(infile);

		isCheck = 0;
		ic2string = (char *)0;

		if (!ep || (errorSpace && strlen(errorSpace)))
		{
			if (!ep && errorSpace && !errorSpace[0])
				strcpy(errorSpace, "Invalid File (could not open)");

			return -1;
		}

		if (errorSpace)
			strcpy(errorSpace, "File Passed");

		return 0;

	case SMAPI_SET_MOVE:
		ssmSetNextMove(infile);
		if (errorSpace)
			strcpy(errorSpace, "Next Move Script Set");
		return 0;
	case SMAPI_SET_COLOR:
		ssmSetNextColor(infile);
		if (errorSpace)
			strcpy(errorSpace, "Next Color Script Set");
		return 0;
	case SMAPI_SET_WAVEFORM:
		ssmSetNextWaveform(infile);
		if (errorSpace)
			strcpy(errorSpace, "Next Waveform Script Set");
		return 0;
	case SMAPI_SET_PARTICLE:
		ssmSetNextParticle(infile);
		if (errorSpace)
			strcpy(errorSpace, "Next Particle Script Set");
		return 0;
	}

	strcpy(errorSpace, "Unknown API function");

	return -1;

}
