#include "smear.h"

#define	SSMF_NONE	0x00

typedef	struct	_smearMemory
{
	char	moveSet;
	char	moveScript[255];

	char	colorSet;
	char	colorScript[255];

	char	waveformSet;
	char	waveformScript[255];

	char	particleSet;
	char	particleScript[255];
}	SmearMemory;

#define	SMEAR_MEM	sizeof(SmearMemory)


static	SmearMemory	*smearMemory = (SmearMemory *)0;
static	HANDLE		hSmearMemory = NULL;


void
ssmSetupMemory(void)
{
	int	doInit = 0;

	if (smearMemory)
		return;

	hSmearMemory = CreateFileMapping(
		(HANDLE) 0xffffffff,
		NULL,
		PAGE_READWRITE,
		0,
		SMEAR_MEM,
		"smearMemory");

	if (hSmearMemory == NULL)
		return;

	doInit = (GetLastError() != ERROR_ALREADY_EXISTS);

	smearMemory = (SmearMemory *)MapViewOfFile(hSmearMemory,
		FILE_MAP_WRITE, 0, 0, 0);

	if (smearMemory == (SmearMemory *)0)
		return;

	if (doInit)
		memset(smearMemory, '\0', SMEAR_MEM);
}


void
ssmCloseMemory(void)
{
	if (smearMemory != (SmearMemory *)0)
	{
		UnmapViewOfFile(smearMemory);
		smearMemory = (SmearMemory *)0;
	}
	if (hSmearMemory != NULL)
	{
		CloseHandle(hSmearMemory);
		hSmearMemory = NULL;
	}
}


void
ssmSetNextWaveform(char *s)
{
	ssmSetupMemory();

	if (!smearMemory || strlen(s) > 254)
		return;

	smearMemory->waveformSet++;
	strcpy(smearMemory->waveformScript, s);

	ssmCloseMemory();
}



void
ssmSetNextParticle(char *s)
{
	ssmSetupMemory();

	if (!smearMemory || strlen(s) > 254)
		return;

	smearMemory->particleSet++;
	strcpy(smearMemory->particleScript, s);

	ssmCloseMemory();
}


void
ssmSetNextMove(char *s)
{
	ssmSetupMemory();

	if (!smearMemory || strlen(s) > 254)
		return;

	smearMemory->moveSet++;
	strcpy(smearMemory->moveScript, s);

	ssmCloseMemory();
}


void
ssmSetNextColor(char *s)
{
	ssmSetupMemory();

	if (!smearMemory || strlen(s) > 254)
		return;

	smearMemory->colorSet++;
	strcpy(smearMemory->colorScript, s);

	ssmCloseMemory();
}


int
ssmGetNextParticle(char *s)
{
	if (!smearMemory)
		return 0;

	if (smearMemory->particleSet <= 0)
		return 0;

	strcpy(s, smearMemory->particleScript);

	smearMemory->particleSet--;

	return 1;
}


int
ssmGetNextMove(char *s)
{
	if (!smearMemory)
		return 0;

	if (smearMemory->moveSet <= 0)
		return 0;

	strcpy(s, smearMemory->moveScript);

	smearMemory->moveSet--;

	return 1;
}


int
ssmGetNextColor(char *s)
{
	if (!smearMemory)
		return 0;

	if (smearMemory->colorSet <= 0)
		return 0;

	strcpy(s, smearMemory->colorScript);

	smearMemory->colorSet--;

	return 1;
}


int
ssmGetNextWaveform(char *s)
{
	if (!smearMemory)
		return 0;

	if (smearMemory->waveformSet <= 0)
		return 0;

	strcpy(s, smearMemory->waveformScript);

	smearMemory->waveformSet--;

	return 1;
}


int
ssmCheckNextMove(void)
{
	if (!smearMemory)
		return 0;

	if (smearMemory->moveSet <= 0)
		return 0;

	return 1;
}


int
ssmCheckNextColor(void)
{
	if (!smearMemory)
		return 0;

	if (smearMemory->colorSet <= 0)
		return 0;

	return 1;
}


int
ssmCheckNextWaveform(void)
{
	if (!smearMemory)
		return 0;

	if (smearMemory->waveformSet <= 0)
		return 0;

	return 1;
}


int
ssmCheckNextParticle(void)
{
	if (!smearMemory)
		return 0;

	if (smearMemory->particleSet <= 0)
		return 0;

	return 1;
}
