/*		
*		Text Output Routines v1.0
*		Coded by Samuel Graenacher
*		for the Starwave2 Project.
*		Copyright pending... just don't copy it w/o permission etc.
*		It's a lame way to do it, I know.. but it at least IS a way.
*
*/

#include <windows.h>
#include "bmpload.h"
#include "textoutput.h"


#define CHAR_WIDTH	    10
#define CHAR_HEIGHT   10

#define _t_SetPixel(Buffer, x, y, pitch, col)			\
	if( y < height && y >= 0 && x >= 0 && x < width )	\
		Buffer[(y*pitch)+x] = col

#define _t_ARGB(a, r, g, b) (RGB(r,g,b) | ((BYTE)a<<24))



static textpixel		* txtscreen = NULL;
static int				txtscreenwidth = 0;
static int				txtscreenheight = 0;

const char			* textarray = "ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890:-/\\._ \0";

bitmaptype charsbmp;
unsigned char  *chars;		// Pointer to the charbitmap


#define	_t_MYFREE(p)	_t_myfree((void **)&p)
void
_t_myfree(void **vp)
{
	if (*vp)
	{
		free(*vp);
		*vp = (void *)0;
	}
}

// Initialize and load the bitmaps in the according sizes.
bool textInit(int cwidth, int cheight)
{
	if ( bmp_load( "text.bmp", charsbmp ) != BMP_NOERROR ) return 0;

	chars = charsbmp.cBitmap;

	_t_MYFREE(txtscreen);
	txtscreen = (textpixel *)malloc(sizeof( textpixel ) * cwidth * cheight);
	memset(txtscreen, '\0', sizeof( textpixel ) * cwidth * cheight);
	txtscreenwidth = cwidth;
	txtscreenheight = cheight;

	return 1;
}


// Subfunction used to write single characters
BOOL textWriteCharToPos(int x, int y, char letter, int expiry)
{
	int cbmpx = 0;
	int cbmpy = 0;
	int jr = 0;
	int ir = 0;

	cbmpx = (StrChrI(textarray, letter) * CHAR_WIDTH);

	for (jr = cbmpy; jr <= (cbmpy + CHAR_HEIGHT); jr= jr+1)
	{
		for (ir = cbmpx; ir <= (cbmpx + CHAR_WIDTH); ir= ir+1)
		{
			if ( chars[(jr * charsbmp.width) + ir] == 0 )		// If the pixel has colorvalue black (assuming it's black) ignore it
			{
				continue;
			}
			txtscreen[( (y+jr) * txtscreenwidth ) + (x+ir)].expin = expiry;
			txtscreen[( (y+jr) * txtscreenwidth ) + (x+ir)].r_col  = 255;
			txtscreen[( (y+jr) * txtscreenwidth ) + (x+ir)].g_col  = 255;
			txtscreen[( (y+jr) * txtscreenwidth ) + (x+ir)].g_col  = 255;
		}
	}
	
	return 1;
}

// Main function used to write out strings
// Use this!
void textWriteStringToPos(int x, int y, char* string2write, int expiry)
{
	int instringpos = 0;
	for ( instringpos = 0 ; instringpos <= (strlen(string2write)-1) ; instringpos=instringpos+1 )
	{
		textWriteCharToPos( x + (instringpos * CHAR_WIDTH), y, string2write[instringpos], expiry);
	}
}

// Function used to Output the texts, with a nice expiry effect
void textTextToVideo(unsigned long* vid, unsigned char* sbbuffer, int width, int height)
{
	for (int j = 0 ; j <= height ; j++ )
	{
		for (int i = 0 ; i <=width ; i++ )
		{
			if ( txtscreen[(j* txtscreenwidth)+i].expin == 0 ) { continue; }

			_t_SetPixel(*vid, i, j, width, _t_ARGB(255, 
																		txtscreen[(j* txtscreenwidth)+i].r_col, 
																		txtscreen[(j* txtscreenwidth)+i].g_col, 
																		txtscreen[(j* txtscreenwidth)+i].b_col)
			
			 txtscreen[(j* txtscreenwidth)+i].expin--;
			 
			 if ( txtscreen[(j* txtscreenwidth)+i].expin == 0)	// Has just expired.. lets write it to the sbbuffer :)
			 {
					//sbData[0][(y % _height) * _width + x] = 255;
					sbbuffer[(j % height) * width + i) = 255;
			 }

		}
	}
}

// Unload the big buffers
void textDeInit(void)
{
	_t_MYFREE( txtscreen );
	bmp_free( charsbmp );
}